type FILE;

union fwhence {
	void SEEK_SET;
	void SEEK_CUR;
	void SEEK_END;
}

FILE fopen(string filename, string flags) = "Stdio__fopen";
FILE fdopen(int fd, string flags) = "Stdio__fdopen";
FILE popen(FILE f) = "Stdio__popen";
int pclose(FILE f) = "Stdio__pclose";
string fgets(FILE f) = "Stdio__fgets";
void fputs(FILE f, string s) = "Stdio__fputs";
bool feof(FILE f) = "Stdio__feof";
bool ferror(FILE f) = "Stdio__ferror";
void clearerr(FILE f) = "Stdio__clearerr";
int fileno(FILE f) = "Stdio__fileno";
string fread(FILE f, int cnt) = "Stdio__fread";
void fflush(FILE f) = "Stdio__fflush";
void fclose(FILE f) = "Stdio__fclose";
void fseek(FILE f, int offset, fwhence whence) = "Stdio__fseek";
int ftell(FILE f) = "Stdio__ftell";
void rewind(FILE f) = "Stdio__rewind";
void setlinebuf(FILE f) = "Stdio__setlinebuf";
void setnobuf(FILE f) = "Stdio__setnobuf";

/* File functions. */
void remove(string filename) = "Stdio__remove";
void rename(string oldname, string newname) = "Stdio__rename";

/* Returns name of created file in addition to FILE object. Example usage:
 * let [f, name] = tmpfile("/tmp/foobar"); If prefix is "" $TMPDIR is
 * used. */
*[FILE, string] tmpfile(string prefix);
